<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { computed, onMounted, reactive, ref } from "vue";
import type {
  NestedWorkflowParameters,
  FlatWorkflowParameters,
} from "@/types/WorkflowParameters";
import { flattenParameters } from "@/utils/Workflow";
import ParameterTable from "@/components/workflows/ParameterTable.vue";
import { type RouteLocationRaw, useRouter } from "vue-router";
import { Modal } from "bootstrap";

const props = defineProps<{
  modalId: string;
}>();

const parameterState = reactive<{
  params?: NestedWorkflowParameters;
  error?: string;
}>({
  params: undefined,
  error: undefined,
});

const router = useRouter();
const randomIDSuffix = Math.random().toString(16).substring(2, 8);
const parameterFileInput = ref<HTMLInputElement | undefined>(undefined);
let parameterModal: Modal | null = null;

const emit = defineEmits<{
  (e: "parameters-uploaded", params: NestedWorkflowParameters): void;
}>();

function emitParameters() {
  if (parameterState.params != undefined) {
    emit("parameters-uploaded", parameterState.params);
    parameterState.params = undefined;
    if (parameterFileInput.value != undefined) {
      parameterFileInput.value.value = "";
    }
  }
}

const flatParameters = computed<FlatWorkflowParameters | undefined>(() => {
  if (parameterState.params == undefined) {
    return undefined;
  }
  return flattenParameters(parameterState.params);
});

function fileChange() {
  if (!parameterFileInput.value?.value?.length) return;
  parameterFileInput.value?.files?.[0].text().then((str) => {
    try {
      parameterState.params = JSON.parse(str);
      parameterState.error = undefined;
    } catch (err) {
      parameterState.params = undefined;
      if (typeof err === "string") {
        parameterState.error = err;
      } else if (err instanceof Error) {
        parameterState.error = err.message;
      } else {
        parameterState.error = "unknown error";
      }
      if (parameterFileInput.value != undefined) {
        parameterFileInput.value.value = "";
      }
    }
  });
}

function handleLinkClick(route: RouteLocationRaw) {
  parameterModal?.hide();
  router.push(route);
}

onMounted(() => {
  parameterModal = Modal.getOrCreateInstance("#" + props.modalId);
});
</script>

<template>
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    modal-label="Upload Parameters Modal"
    size-modifier-modal="lg"
  >
    <template #header>Upload Parameter File</template>
    <template #body>
      <label :for="'parameter-upload-input' + randomIDSuffix" class="form-label"
        >Parameter File</label
      >
      <input
        :id="'parameter-upload-input' + randomIDSuffix"
        ref="parameterFileInput"
        class="form-control mb-3"
        type="file"
        accept="application/json"
        @change="fileChange"
      />
      <template v-if="parameterState.error">
        <h5 class="text-danger">Error parsing JSON</h5>
        <p class="text-danger">{{ parameterState.error }}</p>
      </template>
      <template v-else-if="flatParameters">
        <h5>Uploaded Parameters:</h5>
        <parameter-table
          :parameters="{ params: parameterState.params }"
          @link-clicked="handleLinkClick"
        />
      </template>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        :disabled="parameterState.params == undefined"
        type="button"
        class="btn btn-primary"
        data-bs-dismiss="modal"
        @click="emitParameters"
      >
        Upload
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
